# SYSTEM FONT STACKS

This JS/JSON micro-library provides an opinionated selection of pre-defined web-safe and system font stacks for consumption by Node ecosystem build tools and applications. Just `npm install system-font-stacks --save-dev` and `import stacks from 'system-font-stacks'` and you're ready to go, nothing more to it. Each stack is an array of font names, use them however you wish.

The font stacks themselves are the product of years of idle research, some hands-on experience, and a lot of guesswork. I don't pretend to be an expert in these matters but then again, who is? Most of the articles written about web-safe font stacks are years old and usage data is lousy and poorly-sourced for the most part. I have at least gone to the trouble of sprinkling most font stacks with a few free and open source alternatives so as to not ignore Linux users the way some designers do.

Sane, informed, and reasonably well-documented pull requests are welcome!



## Links

* [Font Family Reunion](http://fontfamily.io/): compatibility tables for default system fonts.
* [The New System Font Stack](https://bitsofco.de/the-new-system-font-stack/): a little more about where the `system-sans` stack came from in 2016.



## Credits

Many of these font stacks are modifications of font stacks I've collected over the years. Many of my sources are no longer online. Among those that *might* still be around: [this post by Michael Tuck](http://www.sitepoint.com/eight-definitive-font-stacks/), [this post on A Way Back](http://www.awayback.com/revised-font-stack/), [this post on Mighty Meta](http://www.mightymeta.co.uk/web-safe-fonts-cheat-sheet-v-3-with-font-face-fonts-and-os-breakdown/), some tips about Futura and Century Gothic on [Intavent](http://intavant.com/), a cursory inspection of [Dan's Tools](http://www.cssfontstack.com/), and [the Wayback Machine](https://webcache.googleusercontent.com/search?q=cache:http://www.visibone.com/font/FontResults.html&gws_rd=cr&ei=CazNVMvABsT38QWgjYD4CQ).



## License

MIT/GPLv3.
