<?php

/*
  Example:
  array(
  'name' =>	Source the embeded media comes from
  'website' =>	URI of the media source
  'url-match' =>	Regexp for matching the submitted url to a stub
  'embed-src' =>	The source of the media to embed.	Replace $2, $3, etc with matches from the url-match or fetch-match regexp ($1 is the entire matched url)
  'embed-width' =>	The default width of the embeded object
  'embed-height' =>	The default width of the embeded object
  'fetch-match' => (optional) if set, html will be fetched and this regexp will be used to pull the media id or the source of the video
  'flashvars' => (optional) if set, will be passed in the embed tag.	Replace $2, $3, etc with matches from url-match or fetch-match
  'id' => to get only the id if possible (set to false if impossible), defaults to $2
  'slug' => identification for pure IDs to retrieve embed tag (defaults to strtolower + autosluggable behavior)
  'replace' => to force-replace certain parts/placeholders
  ),

  TODO: pages like in.com => resolve into actual website and parse it then?

 */
$stubs = [
	/*
	  // Embedding is only available for videos - with playlist as optional param
	  array(
	  'name' => 'YouTube (Playlists)',
	  'website' => 'https://www.youtube.com',
	  'url-match' => 'https?://(?:(?:m|www|au|br|ca|es|fr|de|hk|ie|in|il|it|jp|kr|mx|nl|nz|pl|ru|tw|uk)\.)?youtube\.com(?:[^"]*?)?(?:&|&amp;|/|\?|;)(?:id=|p=|p/)([0-9a-f]{16})',
	  'embed-src' => 'https://www.youtube.com/p/$2&rel=0&fs=1',
	  'embed-width' => '480',
	  'embed-height' => '385',
	  'iframe-player' => 'https://www.youtube.com/embed/$2',
	  ),
	 */
	[
		'name' => 'YouTube',
		'website' => 'https://www.youtube.com',
		'url-match' => [
			'https?://youtu\.be/([0-9a-z-_]{11})',
			'https?://(?:video\.google\.(?:com|com\.au|co\.uk|de|es|fr|it|nl|pl|ca|cn)/(?:[^"]*?))?(?:(?:m|www|au|br|ca|es|fr|de|hk|ie|in|il|it|jp|kr|mx|nl|nz|pl|ru|tw|uk)\.)?youtube\.com(?:[^"]*?)?(?:&|&amp;|/|\?|;|\%3F|\%2F)(?:video_id=|v(?:/|=|\%3D|\%2F)|embed(?:/|=|\%3D|\%2F))([0-9a-z-_]{11})',
			'https?://(www\.)?youtube\.com/shorts/([0-9a-z-_A-Z]{11})',
			'https?://(www\.)?youtube\.com/shorts/([0-9a-z-_A-Z]{11})\?feature=share'
		],
		'embed-src' => 'https://www.youtube.com/v/$2&rel=0&fs=1',
		'embed-width' => '480',
		'embed-height' => '295',
		'image-src' => '//img.youtube.com/vi/$2/0.jpg',
		'iframe-player' => '//www.youtube.com/embed/$2',
	],
	[
		'name' => 'Coub',
		'website' => 'https://coub.com',
		'url-match' => [
			'https?://coub.com/view/([0-9a-z-_]{4,7})',
		],
		'embed-src' => 'https://coub.com/view/$2',
		'embed-width' => '640',
		'embed-height' => '360',
		'iframe-player' => '//coub.com/embed/$2',
	],
	[
		'name' => 'Facebook',
		'website' => 'https://www.facebook.com',
		'url-match' => [
			'https://www.facebook.com/[0-9a-z-_.]+/videos/([0-9]+)/',
			'https://www.facebook.com/[0-9a-zA-Z-_.]+/videos/(?:vb.\d+)/(\d+)/',
			'https://www.facebook.com/[0-9a-zA-Z-_.]+/videos/(?:vl.\d+)/(\d+)/'
		],
		'embed-src' => '//www.facebook.com/video/embed?video_id=$2',
		'embed-width' => '480',
		'embed-height' => '295',
		'iframe-player' => '//www.facebook.com/plugins/video.php?href=$1&show_text=0',
	],
	[
		'name' => 'Dailymotion',
		'website' => 'https://www.dailymotion.com',
		'url-match' => [
			'https://dai\.ly/([a-z0-9]{1,})',
			'https://(?:www\.)?dailymotion\.(?:com|alice\.it)/(?:(?:[^"]*?)?video|swf)/([a-z0-9]{1,18})',
		],
		'embed-src' => 'https://www.dailymotion.com/swf/$2&related=0',
		'embed-width' => '420',
		'embed-height' => '339',
		'image-src' => 'https://www.dailymotion.com/thumbnail/160x120/video/$2',
		'iframe-player' => '//www.dailymotion.com/embed/video/$2'
	],
	[
		'name' => 'MetaCafe',
		'website' => 'https://www.metacafe.com',
		'url-match' => 'https?://(?:www\.)?metacafe\.com/(?:watch|fplayer)/(\w{1,10})/',
		'embed-src' => 'https://www.metacafe.com/fplayer/$2/metacafe.swf',
		'embed-width' => '400',
		'embed-height' => '345',
	],
	[
		'name' => 'Vimeo',
		'website' => 'https://www.vimeo.com',
		'url-match' => 'https?:\/\/(www\.)?vimeo.com\/(channels\/[a-zA-Z0-9]*\/)?([0-9]*)(?:\/[a-zA-Z0-9]+)?(\#t=(\d+)s)?',
		'embed-src' => 'https://vimeo.com/moogaloop.swf?clip_id=$2&server=vimeo.com&fullscreen=1&show_title=1&show_byline=1&show_portrait=0&color=01AAEA',
		'embed-width' => '400',
		'embed-height' => '302',
		'iframe-player' => '//player.vimeo.com/video/$2',
	],
	[
		'name' => '123video',
		'website' => 'https://www.123video.nl',
		'url-match' => 'https?://(?:www\.)?123video\.nl/(?:playvideos\.asp\?(?:[^"]*?)?MovieID=|123video_share\.swf\?mediaSrc=)([0-9]{1,8})',
		'embed-src' => 'https://www.123video.nl/123video_share.swf?mediaSrc=$2',
		'embed-width' => '420',
		'embed-height' => '339',
	],
	[
		'name' => 'AOL Video (Old)',
		'website' => 'https://video.aol.com',
		'url-match' => 'https?://video\.aol\.com/video/([a-z0-9-_]+)/([a-z0-9:\.]+)',
		'embed-src' => 'https://media.mtvnservices.com/$4',
		'embed-width' => '415',
		'embed-height' => '347',
	],
	[
		'name' => 'Aparat',
		'website' => 'https://www.aparat.com',
		'url-match' => 'https?://www.aparat.com/v/([A-z0-9-_]+)(?:/.*)?',
		'embed-src' => '',
		'embed-width' => '425',
		'embed-height' => '354',
		'iframe-player' => 'https://www.aparat.com/video/video/embed/videohash/$2/vt/frame/'
	],
	[
		'name' => 'Archive.org',
		'website' => 'https://www.archive.org',
		'url-match' => 'https?://(?:www\.)?archive\.org/download/((?:[0-9a-z_-]*?)/(?:[0-9a-z_-]*?)\.flv)',
		'embed-src' => 'https://www.archive.org/flow/FlowPlayerLight.swf?config=%7Bembedded%3Atrue%2CshowFullScreenButton%3Atrue%2CshowMuteVolumeButton%3Atrue%2CshowMenu%3Atrue%2CautoBuffering%3Afalse%2CautoPlay%3Afalse%2CinitialScale%3A%27fit%27%2CmenuItems%3A%5Bfalse%2Cfalse%2Cfalse%2Cfalse%2Ctrue%2Ctrue%2Cfalse%5D%2CusePlayOverlay%3Afalse%2CshowPlayListButtons%3Atrue%2CplayList%3A%5B%7Burl%3A%27$2%27%7D%5D%2CcontrolBarGloss%3A%27high%27%2CshowVolumeSlider%3Atrue%2CbaseURL%3A%27http%3A%2F%2Fwww%2Earchive%2Eorg%2Fdownload%2F%27%2Cloop%3Afalse%2CcontrolBarBackgroundColor%3A%270x000000%27%7D',
		'embed-width' => '480',
		'embed-height' => '360',
	],
	[
		'name' => 'Brightcove.com',
		'website' => 'https://link.brightcove.com',
		'url-match' => 'https?://link\.brightcove\.com/services/link/bcpid([0-9]+)/bctid([0-9]+)',
		'embed-src' => 'https://services.brightcove.com/services/viewer/federated_f8/$2?videoId=$3&playerId=$2&viewerSecureGatewayURL=https://console.brightcove.com/services/amfgateway&servicesURL=https://services.brightcove.com/services&cdnURL=https://admin.brightcove.com&domain=embed&autoStart=false&',
		'embed-width' => '486',
		'embed-height' => '412',
	],
	[
		'name' => 'CBS News',
		'website' => 'https://www.cbsnews.com/video',
		'url-match' => 'https?://(?:www\.)?cbsnews\.com/video/watch/',
		'fetch-match' => 'CBSVideo\.setVideoId\(.([a-z0-9-_]{1,32}).\)',
		'embed-src' => 'https://cnettv.cnet.com/av/video/cbsnews/atlantis2/player-dest.swf',
		'embed-width' => '425',
		'embed-height' => '324',
		'flashvars' => 'tag=contentBody;housing&releaseURL=https://cnettv.cnet.com/av/video/cbsnews/atlantis2/player-dest.swf&videoId=$2&partner=news&vert=News&autoPlayVid=false&name=cbsPlayer&allowScriptAccess=always&wmode=transparent&embedded=y&scale=noscale&rv=n&salign=tl'
	],
	[
		'name' => 'Cellfish',
		'website' => 'https://www.cellfish.com',
		'url-match' => 'https?://(cellfish\.|www\.)?cellfish\.com/(?:video|ringtone|multimedia)/([0-9]{1,10})/',
		'embed-src' => 'https://$2cellfish.com/static/swf/player8.swf?Id=$3',
		'embed-width' => '420',
		'embed-height' => '315',
	],
	[
		'name' => 'Clarin',
		'website' => 'https://www.videos.clarin.com',
		'url-match' => 'https?://(?:www\.)videos\.clarin\.com/index\.html\?id=([0-9]{1,12})',
		'embed-src' => 'https://www.clarin.com/shared/v9/swf/clarinvideos/player.swf',
		'embed-width' => '533',
		'embed-height' => '438',
		'flashvars' => 'autoplay=false&amp;SEARCH=https://www.videos.clarin.com/decoder/buscador_getMtmYRelacionados/$2|CLARIN_VIDEOS|VIDEO|EMBEDDED|10|1|10|null.xml&amp;RUTAS=https://www.clarin.com/shared/v9/swf/clarinvideos/rutas.xml',
	],
	[
		'name' => 'Clip.vn',
		'website' => 'https://www.clip.vn',
		'url-match' => 'https?://(?:www\.)?clip\.vn/w(?:atch/(?:[a-z0-9-_]*?))?/([a-z0-9_-]{1,5}),vn',
		'embed-src' => 'https://www.clip.vn/w/$2,vn,0,,hq',
		'embed-width' => '448',
		'embed-height' => '361',
	],
	//TODO: combine these three
	[
		'slug' => 'clipfish-old',
		'name' => 'ClipFish (Old)',
		'website' => 'https://www.clipfish.de',
		'url-match' => 'https?://(?:www\.)?clipfish\.de/(?:(?:player\.php|videoplayer\.swf)\?(?:[^"]*?)?vid=|video/)([0-9]{1,20})',
		'embed-src' => 'https://www.clipfish.de/videoplayer.swf?as=0&vid=$2&r=1',
		'embed-width' => '464',
		'embed-height' => '380',
		'iframe-player' => 'https://www.clipfish.de/embed_video/?vid=$2'
	],
	[
		'slug' => 'clipfish-special',
		'name' => 'ClipFish (Special)',
		'website' => 'https://www.clipfish.de',
		'url-match' => 'https?://(?:www\.)?clipfish\.de/(?:[^"]*?)/video/((?:[a-z0-9]{18})(?:==)?|(?:[a-z0-9]{6,7})(?:==)?)',
		'embed-src' => 'https://www.clipfish.de/videoplayer.swf?as=0&videoid=$2%3D%3D&r=1',
		'embed-width' => '464',
		'embed-height' => '380',
		'iframe-player' => 'https://www.clipfish.de/embed_video/?vid=$2'
	],
	[
		'slug' => 'clipfish',
		'name' => 'ClipFish (New)',
		'website' => 'https://www.clipfish.de',
		'url-match' => 'https?://(?:www\.)?clipfish\.de/(?:video)?player\.(?:swf|php)(?:[^"]*?)videoid=((?:[a-z0-9]{18})(?:==)?|(?:[a-z0-9]{6})(?:==)?)',
		'embed-src' => 'https://www.clipfish.de/videoplayer.swf?as=0&videoid=$2%3D%3D&r=1',
		'embed-width' => '464',
		'embed-height' => '380',
		'iframe-player' => 'https://www.clipfish.de/embed_video/?vid=$2'
	],
	[
		'name' => 'ClipMoon',
		'website' => 'https://www.clipmoon.com',
		'url-match' => 'https?://(?:www\.)?clipmoon\.com/(?:videos/|(?:[^"]*?)viewkey=)([0-9a-z]{1,10})',
		'embed-src' => 'https://www.clipmoon.com/flvplayer.swf?config=https://www.clipmoon.com/flvplayer.php?viewkey=$2&external=yes',
		'embed-width' => '460',
		'embed-height' => '357',
	],
	[
		'name' => 'ClipShack',
		'website' => 'https://www.clipshack.com',
		'url-match' => 'https?://(?:www\.)?clipshack\.com/Clip\.aspx\?key=([0-9a-f]{16})',
		'embed-src' => 'https://www.clipshack.com/player.swf?key=$2',
		'embed-width' => '430',
		'embed-height' => '370',
	],
	[
		'name' => 'CNetTV',
		'website' => 'https://cnettv.cnet.com',
		'url-match' => 'https?://cnettv\.cnet\.com/[a-z0-9\-]*\/[0-9]{4}-[0-9]_[0-9]{2}-([0-9]{5,9})\.html',
		'embed-src' => 'https://www.cnet.com/av/video/flv/universalPlayer/universalSmall.swf',
		'embed-width' => '364',
		'embed-height' => '280',
		'flashvars' => 'playerType=embedded&type=id&value=$2',
	],
	[
		'name' => 'TheDailyShow',
		'website' => 'https://www.thedailyshow.com',
		'url-match' => 'https?://(?:www\.)?thedailyshow\.com/(?:watch|full\-episodes)',
		'fetch-match' => 'swfo.embedSWF\(.*(https://media.mtvnservices.com/mgid:cms:(video|fullepisode):comedycentral\.com:[0-9]{1,10})',
		'embed-src' => '$2',
		'embed-width' => '360',
		'embed-height' => '301',
	],
	[
		'name' => 'ColbertNation',
		'website' => 'https://www.colbertnation.com',
		'url-match' => 'https?:\/\/(?:www\.)?colbertnation\.com\/the-colbert-report-videos\/([0-9]*)\/',
		'embed-src' => 'https://media.mtvnservices.com/mgid:cms:item:comedycentral.com:$2',
		'embed-width' => '360',
		'embed-height' => '301',
	],
	[
		'name' => 'Crackle',
		'website' => 'https://www.crackle.com',
		'url-match' => 'https?://(?:www\.)?crackle\.com/c/([a-z0-9_-]*?)/([a-z0-9_-]*?)/([0-9]{1,10})',
		'embed-src' => 'https://www.crackle.com/p/$2/$3.swf?id=$4',
		'embed-width' => '400',
		'embed-height' => '328',
	],
	[
		'name' => 'CrunchyRoll',
		'website' => 'https://www.crunchyroll.com',
		'url-match' => 'https?://(?:www\.)?crunchyroll\.com/[a-z0-9\-_]+/[a-z0-9\-_]+-([0-9]{1,12})',
		'embed-src' => ' https://www.crunchyroll.com/flash/20080910153703.043ec803b06cc356a1e15c1184831a24/oldplayer2.swf?file=http%3A%2F%2Fwww.crunchyroll.com%2Fgetitem%3Fih%3D$2%26videoid%3D$3%26mediaid%3D$4%26hash%3D$5&autostart=false',
		'embed-width' => '576',
		'embed-height' => '325',
	],
	[
		'name' => 'Current',
		'website' => 'https://www.current.com',
		'url-match' => 'https?://(?:www\.)?current\.com/items/([0-9]{8})',
		'embed-src' => 'https://current.com/e/$2/en_US',
		'embed-width' => '400',
		'embed-height' => '400',
	],
	[
		'name' => 'Dailyhaha',
		'website' => 'https://www.dailyhaha.com',
		'url-match' => 'https?://(?:www\.)?dailyhaha\.com/_vids/(?:Whohah\.swf\?Vid=)?([a-z0-9_-]*?)\.(?:htm|flv)',
		'embed-src' => 'https://www.dailyhaha.com/_vids/Whohah.swf?Vid=$2.flv',
		'embed-width' => '425',
		'embed-height' => '350',
	],
	[
		'name' => 'DotSub (w/o Captions)',
		'website' => 'https://www.dotsub.com',
		'url-match' => 'https?://(?:www\.)?dotsub\.com/(?:media/|view/)((?:[0-9a-z]{8})(?:(?:-(?:[0-9a-z]{4})){3})-(?:[0-9a-z]{12}))',
		'embed-src' => 'https://dotsub.com/static/players/embed8l.swf?mediauri=https://dotsub.com/media/$2/em/flv/en',
		'embed-width' => '480',
		'embed-height' => '392',
	],
	[
		'name' => 'Dropshots',
		'website' => 'https://www.dropshots.com',
		'url-match' => '(https://media(?:[0-9]{0,2})\.dropshots\.com/photos(?:(?:/(?:[0-9]{1,10})){1,3})\.flv)',
		'embed-src' => 'https://www.dropshots.com/dropshotsplayer.swf?url=$2',
		'embed-width' => '480',
		'embed-height' => '385',
	],
	[
		'name' => 'Divshare',
		'website' => 'https://www.divshare.com',
		'url-match' => 'https?://www\.divshare\.com/download/([^"]*)',
		'embed-src' => 'https://www.divshare.com/flash/playlist?myId=$2',
		'embed-width' => '335',
		'embed-height' => '28',
	],
	[
		'name' => 'EASportsWorld',
		'website' => 'https://www.easportsworld.com',
		'url-match' => '(https://videocdn\.easw\.easports\.com/easportsworld/media/(?:[0-9]{1,12})/(?:[0-9a-z-_]*?)\.flv)',
		'embed-src' => 'https://ll-999.ea.com/sonet-easw/2.2.4.0/flash/sw/videos/mediaplayer.swf?file=$2&image=https://ll-999.ea.com/sonet-easw/2.2.4.0/images/sw/videos/preview.jpg&backcolor=0x000000&frontcolor=0x006BCC&lightcolor=0x006BCC',
		'embed-width' => '566',
		'embed-height' => '355',
	],
	[
		'name' => 'EbaumsWorld',
		'website' => 'https://www.ebaumsworld.com',
		'url-match' => 'https?://www\.ebaumsworld\.com/(?:video|audio)/(?:watch|play)/([0-9]*)',
		//'fetch-match' => 'id="embed".*flashvars=&quot;(.*)&quot;\ wmode',
		'embed-src' => 'https://www.ebaumsworld.com/player.swf',
		'embed-width' => '567',
		'embed-height' => '345',
		'flashvars' => 'id1=$2',
	],
	[
		'name' => 'ESPN',
		'website' => 'https://www.espn.com',
		'url-match' => 'https?:\/\/espn\.go\.com\/video\/clip\?id=([0-9a-z]*)',
		'embed-src' => 'https://espn.go.com/videohub/player/embed.swf',
		'embed-width' => '384',
		'embed-height' => '216',
		'flashvars' => 'id=$2',
	],
	[
		'name' => 'Flickr',
		'website' => 'https://www.flickr.com',
		'url-match' => 'https?://(?:www\.|www2\.)?flickr\.com/photos/[A-Za-z0-9-_@]*/([0-9]{8,12})',
		'fetch-match' => 'id="stewart_swf([0-9]{8,12})_div"',
		'embed-src' => 'https://www.flickr.com/apps/video/stewart.swf',
		'embed-width' => '400',
		'embed-height' => '300',
		'flashvars' => 'intl_lang=en-us&amp;photo_id=$2',
	],
	# 2011-02-09 ms - TODO: https://www.foxhead.com/us/mx/videos/id/23798
	[
		'name' => 'Foxhead',
		'website' => 'https://www.foxhead.com',
		'url-match' => 'https?://(?:www\.)?foxhead\.com/(?:[^"]*?)/videos/id/([0-9]{4,8})',
		'embed-src' => 'https://www.foxhead.com/videos/player.swf',
		'embed-width' => '425',
		'embed-height' => '285',
		'flashvars' => 'id=$2',
		'id' => '$2',
	],
	[
		'name' => 'FunnyOrDie',
		'website' => 'https://www.funnyordie.com',
		'url-match' => 'https?://(?:www\.|www2\.)?funnyordie\.com/(?:videos/|public/flash/fodplayer\.swf\?key=)([0-9a-z]{8,12})',
		'embed-src' => 'https://player.ordienetworks.com/flash/fodplayer.swf',
		'embed-width' => '464',
		'embed-height' => '388',
		'flashvars' => 'key=$2',
	],
	[
		'name' => 'G4TV',
		'website' => 'https://www.g4tv.com',
		'url-match' => 'https?://(?:www\.)?g4tv\.com/(?:xplay/videos/|lv3/|sv3/)([0-9]{1,10})',
		'embed-src' => 'https://www.g4tv.com/lv3/$2',
		'embed-width' => '480',
		'embed-height' => '418',
	],
	[
		'name' => 'GameKyo',
		'website' => 'https://www.gamekyo.com',
		'url-match' => 'https?://(?:www\.)?gamekyo\.com/(?:video|flash/flvplayer\.swf\?videoid=)[a-z]{2}([0-9]{1,7})',
		'embed-src' => 'https://www.gamekyo.com/flash/flvplayer.swf?videoid=$2',
		'embed-width' => '512',
		'embed-height' => '307',
	],
	[
		'name' => 'GameSpot',
		'website' => 'https://www.gamespot.com',
		'url-match' => 'https?://(?:(?:[a-z]*?)\.)?gamespot\.com/(?:[^"]*?)video/(?:(?:[0-9]{1,12})/)?([0-9]{1,12})',
		'embed-src' => 'https://image.com.com/gamespot/images/cne_flash/production/media_player/proteus/one/proteus2.swf',
		'embed-width' => '432',
		'embed-height' => '362',
		'flashvars' => 'skin=https://image.com.com/gamespot/images/cne_flash/production/media_player/proteus/one/skins/gamespot.png&paramsURI=http%3A%2F%2Fwww.gamespot.com%2Fpages%2Fvideo_player%2Fxml.php%3Fid%3D$2%26mode%3Dembedded%26width%3D432%26height%3D362%2F',
	],
	[
		'name' => 'GameTrailers (Inc. User Movies)',
		'website' => 'https://www.gametrailers.com',
		'url-match' => 'https?://(?:www\.)?gametrailers\.com/(?:player/(u)?(?:sermovies/)?|remote_wrap\.php\?(u)?mid=)([0-9]{1,10})',
		'embed-src' => 'https://www.gametrailers.com/remote_wrap.php?$2$3mid=$4', //Either $2 or $3 will be empty
		'embed-width' => '480',
		'embed-height' => '392',
	],
	[
		'name' => 'GarageTv',
		'website' => 'https://www.garagetv.be',
		'url-match' => '(https://www\.garagetv\.be/v/(?:[0-9a-z-\!_]*?)/v\.aspx)',
		'embed-src' => '$2',
		'embed-width' => '430',
		'embed-height' => '369',
	],
	[
		'name' => 'Gloria',
		'website' => 'https://www.gloria.tv',
		'url-match' => 'https?://(?:www\.)?gloria\.tv/\?video=([a-z0-9]{20})',
		'embed-src' => 'https://www.gloria.tv/flvplayer.swf?file=http%3A%2F%2Fwww.gloria.tv%2F%3Fembed%26video%3D$2%26width%3D512%26height%3D288&type=flv&image=http%3A%2F%2Fwww.gloria.tv%2F%3Fembed%26image%3D$2%26width%3D512%26height%3D288&autostart=false&showdigits=true&usefullscreen=false&logo=http%3A%2F%2Fwww.gloria.tv%2Fimage%2Flogo_embed.png&link=http%3A%2F%2Fwww.gloria.tv%2F%3Fvideo%3Dddexrl6eelym3gaabxmz%26amp%3Bview%3Dflash&linktarget=_blank&volume=100&backcolor=0xe0e0e0&frontcolor=0x000000&lightcolor=0xf00000',
		'embed-width' => '512',
		'embed-height' => '404',
	],
	[
		'name' => 'Good.IS',
		'website' => 'https://www.good.is',
		'url-match' => 'https?://www\.good\.is/\?p=([0-9]{3,7})',
		'fetch-match' => '(https:\/\/s3\.amazonaws\.com\/.*Url=https:\/\/www\.good\.is\/\?p=[0-9]{3,7})&quot;\/&gt;&lt;embed src=&',
		'embed-src' => '$2',
		'embed-width' => '416',
		'embed-height' => '264',
		'flashvars' => '$2',
	],
	[
		'name' => 'GodTube',
		'website' => 'https://www.godtube.com',
		'url-match' => 'https?://(?:www\.)?godtube\.com/view_video\.php\?(?:[^"]*?)?viewkey=([0-9a-f]{20})',
		'embed-src' => 'https://godtube.com/flvplayer.swf?viewkey=$2',
		'embed-width' => '330',
		'embed-height' => '270',
	],
	[
		'name' => 'Howcast',
		'website' => 'https://www.howcast.com',
		'url-match' => 'https?://(?:www\.)?howcast\.com/videos/([0-9]{1,8})',
		'embed-src' => 'https://www.howcast.com/flash/howcast_player.swf?file=$2&theme=black',
		'embed-width' => '432',
		'embed-height' => '276',
	],
	[
		'name' => 'Hulu (Usa Only)',
		'website' => 'https://www.hulu.com',
		'url-match' => 'https?://(?:www\.)?hulu\.com/watch/(?:[0-9]{1,8})/',
		'fetch-match' => '<link rel="video_src" href="([A-z:/\.0-9-_=?]*)',
		'embed-src' => '$2',
		'embed-width' => '512',
		'embed-height' => '296',
	],
	[
		'name' => 'Humour',
		'website' => 'https://www.humour.com',
		'url-match' => 'https?://(?:video|www)\.humour\.com/videos-comiques/videos.asp\?[A-z]*\=([1-9]{1,8})',
		'embed-src' => '/videos-comiques/player/mediaplayer.swf',
		'embed-width' => '425',
		'embed-height' => '355',
	],
	[
		'name' => 'Video.i.ua',
		'website' => 'https://video.i.ua',
		'url-match' => '(https://i1\.i\.ua/video/vp3\.swf\?9&(?:amp;)?userID=(?:[0-9]{1,20})&(?:amp;)?videoID=(?:[0-9]{1,20})&(?:amp;)?playTime=(?:[0-9]{1,20})&(?:amp;)?repeat=0&(?:amp;)?autostart=0&(?:amp;)?videoSize=(?:[0-9]{1,20})&(?:amp;)?userStatus=(?:[0-9]{1,2})&(?:amp;)?notPreview=(?:[0-9]{1,2})&(?:amp;)?mID=m?(?:[0-9]{1,2}))',
		'embed-src' => '$2',
		'embed-width' => '450',
		'embed-height' => '349',
	],
	[
		'name' => 'IGN',
		'website' => 'https://www.ign.com',
		'url-match' => 'https?://(?:(?:(?:[a-z0-9]*?)\.){0,3})ign\.com/(?:[a-z0-9-_]*?)?/objects/([0-9]{1,10})/(?:(?:[a-z0-9-_]*?)/)?videos/',
		'embed-src' => 'https://videomedia.ign.com/ev/ev.swf?object_ID=$2',
		'embed-width' => '433',
		'embed-height' => '360',
	],
	[
		'name' => 'IMDB',
		'website' => 'https://www.imdb.com',
		'url-match' => 'https?://(?:www\.)?totaleclips\.com/Player/Bounce\.aspx\?eclipid=([0-9a-z]{1,12})&(?:amp;)?bitrateid=([0-9]{1,10})&(?:amp;)?vendorid=([0-9]{1,10})&(?:amp;)?type=\.flv',
		'embed-src' => 'https://www.imdb.com/images/js/app/video/mediaplayer.swf?file=http%3A%2F%2Fwww.totaleclips.com%2FPlayer%2FBounce.aspx%3Feclipid%3D$2%26bitrateid%3D$3%26vendorid%3D$4%26type%3D.flv&backcolor=0x000000&frontcolor=0xCCCCCC&lightcolor=0xFFFFCC&shuffle=false&autostart=false',
		'embed-width' => '480',
		'embed-height' => '380',
	],
	[
		'name' => 'ImageShack',
		'website' => 'https://www.imageshack.us',
		'url-match' => 'https?://img([0-9]{1,5})\.imageshack\.us/img[0-9]{1,5}/[0-9]{1,7}/([a-z0-9-_]{1,28})\.(?:flv|swf)',
		'embed-src' => 'https://img$2.imageshack.us/flvplayer.swf?f=T$3&autostart=false',
		'embed-width' => '424',
		'embed-height' => '338',
	],
	[
		'name' => 'Izlesene',
		'website' => 'https://www.izlesene.com',
		'url-match' => 'https?://(?:www\.)?izlesene\.com/(?:player2\.swf\?video=|video/(?:[a-z0-9-_]*?)/)([0-9]{1,10})',
		'embed-src' => 'https://www.izlesene.com/player2.swf?video=$2',
		'embed-width' => '425',
		'embed-height' => '355',
	],
	[
		'name' => 'Jamendo',
		'website' => 'https://www.jamendo.com',
		'url-match' => 'https?://(?:www\.|widgets\.)?jamendo\.com/(?:[a-z0-9]*?)/album/(?:\?album_id=)?([0-9]{1,10})',
		'embed-src' => 'https://widgets.jamendo.com/en/album/?album_id=$2&playertype=2008',
		'embed-width' => '200',
		'embed-height' => '300',
	],
	[
		'name' => 'Jokeroo',
		'website' => 'https://www.jokeroo.com',
		'url-match' => 'https?://(?:www\.)?jokeroo\.com/(auto|educational|financial|health|howto|lawyers|politics|travel|extremesports|funnyvideos)/((?:(?:[0-9a-z]*?)/){0,3})?([0-9a-z_]*?)\.htm',
		'embed-src' => 'https://www.jokeroo.com/promotional_player2.swf?channel&vid=https://uploads.filecabin.com/flash/$4.flv&vid_url=https://www.jokeroo.com/$2/$3$4.html&adv_url',
		'embed-width' => '490',
		'embed-height' => '425',
	],
	[
		'name' => 'JujuNation Video',
		'website' => 'https://www.jujunation.com',
		'url-match' => 'https?://(?:www\.)?jujunation.com/viewVideo\.php\?video_id=([0-9]{1,10})',
		'embed-src' => 'https://www.jujunation.com/flvplayer.swf?config=https://www.jujunation.com/videoConfigXmlCode.php?pg=video_$2_no_0',
		'embed-width' => '450',
		'embed-height' => '370',
	],
	[
		'name' => 'JujuNation Audio',
		'website' => 'https://www.jujunation.com',
		'url-match' => 'https?://(?:www\.)?jujunation.com/music\.php\?music_id=([0-9]{1,10})',
		'embed-src' => 'https://www.jujunation.com/player.swf?configXmlPath=https://www.jujunation.com/musicConfigXmlCode.php?pg=music_$2&playListXmlPath=https://www.jujunation.com/musicPlaylistXmlCode.php?pg=music_$2',
		'embed-width' => '220',
		'embed-height' => '66',
	],
	[
		'name' => 'Kewego',
		'website' => 'https://www.kewego.co.uk',
		'url-match' => 'https?://(?:www\.)?kewego(?:\.co\.uk|\.com)/video/([0-9a-z]*)\.html',
		'embed-src' => 'https://www.kewego.com/swf/p3/epix.swf',
		'embed-width' => '400',
		'embed-height' => '300',
		'flashvars' => 'language_code=en&playerKey=$2&skinKey=71703ed5cea1&sig=iLyROoaftv7I&autostart=false'
	],
	[
		'name' => 'Koreus',
		'website' => 'https://www.koreus.com',
		'url-match' => 'https?://(?:www\.)?koreus\.com/video/([0-9a-z-]{1,50})(?:\.html)?',
		'embed-src' => 'https://www.koreus.com/video/$2',
		'embed-width' => '400',
		'embed-height' => '320',
	],
	[
		'name' => 'Last.fm (Audio)',
		'website' => 'https://www.last.fm',
		'url-match' => 'https?://(?:www\.)?last\.fm/music/([0-9a-z%\+_-]*?)/_/([0-9\+a-z_-]*)',
		'embed-src' => 'https://cdn.last.fm/webclient/s12n/s/53/lfmPlayer.swf',
		'embed-width' => '300',
		'embed-height' => '221',
		'flashvars' => 'lang=en&amp;lfmMode=playlist&amp;FOD=true&amp;resname=$3&amp;restype=track&amp;artist=$2',
	],
	[
		'name' => 'Last.fm (Video)',
		'website' => 'https://www.last.fm',
		'url-match' => 'https?://(?:www\.)?last\.fm/music/([0-9a-zA-Z%\+_-]*?)/\+videos/([0-9\+a-z_-]{2,20})',
		'embed-src' => 'https://cdn.last.fm/videoplayer/l/17/VideoPlayer.swf',
		'embed-width' => '340',
		'embed-height' => '289',
		'flashvars' => 'uniqueName=$3&amp;FSSupport=true&amp;'
	],
	[
		'name' => 'Libero',
		'website' => 'https://www.libero.it',
		'url-match' => 'https?://video\.libero\.it/app/play(?:/index.html)?\?(?:[^"]*?)?id=([a-f0-9]{32})',
		'embed-src' => 'https://video.libero.it/static/swf/eltvplayer.swf?id=$2.flv&ap=0',
		'embed-width' => '400',
		'embed-height' => '333',
	],
	[
		'name' => 'LiveLeak',
		'website' => 'https://www.liveleak.com',
		'url-match' => 'https?://(?:www\.)?liveleak\.com/(?:player.swf?autostart=false&(?:amp;)?token=|view\?(?:[^"]*?)?i=|e/)((?:[0-9a-z]{3})_(?:[a-z0-9]{10}))',
		'embed-src' => 'https://www.liveleak.com/e/$2',
		'embed-width' => '450',
		'embed-height' => '370',
	],
	/*
	  # no videos
	  array(
	  'name' => 'Machinima (Old)',
	  'website' => 'https://www.machinima.com',
	  'url-match' => 'https?://(?:www\.)?machinima\.com/(?:film/view&(?:amp;)?id=|#details_)([0-9]{1,8})(?:_contents)?',
	  'embed-src' => 'https://www.machinima.com/_flash_media_player/mediaplayer.swf?file=https://machinima.com/p/$2',
	  'embed-width' => '400',
	  'embed-height' => '300',
	  ),
	  array(
	  'name' => 'Machinima (New)',
	  'website' => 'https://www.machinima.com',
	  'url-match' => 'https?://(?:www\.)?machinima\.com:80/f/([0-9a-f]{32})',
	  'embed-src' => 'https://machinima.com:80/_flash_media_player/mediaplayer.swf?file=https://machinima.com:80/f/$2',
	  'embed-width' => '400',
	  'embed-height' => '300',
	  ),
	 */
	[
		'name' => 'MSNBC',
		'website' => 'https://www.msnbc.msn.com/',
		'url-match' => 'https?://www\.msnbc\.msn\.com/id/(?:[0-9]{1,9})/vp/([0-9]{1,9})',
		'embed-src' => 'https://msnbcmedia.msn.com/i/MSNBC/Components/Video/_Player/swfs/embedPlayer/EmbeddedPlayer_I4.swf?domain=www.msnbc.msn.com&amp;settings=22425448&amp;useProxy=true&amp;wbDomain=www.msnbc.msn.com&amp;launch=$2&amp;sw=1920&amp;sh=1200&amp;EID=oVPEFC&amp;playerid=22425001',
		'embed-width' => '425',
		'embed-height' => '339',
	],
	[
		'name' => 'Video.mail.ru',
		'website' => 'https://video.mail.ru',
		'url-match' => 'https?://video\.mail\.ru/mail/([0-9a-z_-]*?)/([0-9]{1,4})/([0-9]{1,4})\.html',
		'embed-src' => 'https://img.mail.ru/r/video2/player_v2.swf?par=https://content.video.mail.ru/mail/$2/$3/\$$4&page=1&username=$2&albumid=$3&id=$4',
		'embed-width' => '452',
		'embed-height' => '385',
	],
	[
		'name' => 'MadnessVideo',
		'website' => 'https://www.madnessvideo.net',
		'url-match' => 'https?://(?:www\.)?madnessvideo\.net/(.*)',
		'embed-src' => 'https://www.madnessvideo.net/emb.aspx/$2',
		'embed-width' => '400',
		'embed-height' => '320',
	],
	[
		'name' => 'Matterport',
		'website' => 'https://matterport.com',
		'url-match' => 'https://my\.matterport\.com/show/[?&]m=([0-9a-zA-Z]+)',
		'embed-src' => '',
		'embed-width' => '450',
		'embed-height' => '450',
		'iframe-player' => 'https://my.matterport.com/show/?m=$2',
	],
	[
		'name' => 'Metatube',
		'website' => 'https://www.metatube.com',
		'url-match' => 'https?://www\.metatube\.com/([a-z]+)/videos/([a-z0-9-/]+)/',
		'embed-src' => '',
		'embed-width' => '420',
		'embed-height' => '315',
		'iframe-player' => 'https://www.metatube.com/$2/videos/$3/embed/',
	],
	[
		'name' => 'Mp3tube',
		'website' => 'https://www.mp3tube.net',
		'url-match' => '(https://(?:www\.)?mp3tube\.net\/play\.swf\?id=(?:[0-9a-f]{32}))',
		'embed-src' => '$2',
		'embed-width' => '260',
		'embed-height' => '60',
	],
	[
		'name' => 'MtvU (Usa Only)',
		'website' => 'https://www.mtvu.com',
		'url-match' => 'https?://(?:www\.)?mtvu\.com/video/\?id=([0-9]{1,9})(?:[^"]*?)vid=([0-9]{1,9})',
		'embed-src' => 'https://media.mtvu.com/player/embed/AS3/site/',
		'embed-width' => '423',
		'embed-height' => '318',
		'flashvars' => 'CONFIG_URL=https://media.mtvu.com/player/embed/AS3/site/configuration.jhtml%3fid%3D$2%26vid%3D$3%26autoPlay%3Dfalse&amp;allowFullScreen=true'
	],
	[
		'name' => 'MP3 Audio',
		'website' => '',
		'url-match' => '(https://[^"\'\`\<\>\@\*\$]*?\.mp3)$',
		'embed-src' => 'https://www.google.com/reader/ui/3523697345-audio-player.swf',
		'embed-width' => '400',
		'embed-height' => '27',
		'flashvars' => 'audioUrl=$2'
	],
	[
		'name' => 'MyVideo',
		'website' => 'https://www.myvideo.de',
		'url-match' => 'https?://(?:www\.)?myvideo\.(at|be|ch|de|nl)/(?:watch|movie)/([0-9]{1,8})',
		'embed-src' => 'https://www.myvideo.$2/movie/$3',
		'embed-width' => '470',
		'embed-height' => '406',
		'id' => '$3',
		'replace' => ['$2' => 'de'],
	],
	[
		'name' => 'MyVi',
		'website' => 'https://www.myvi.ru',
		'url-match' => '(https://(?:www\.)?myvi\.ru/ru/flash/player/(?:[0-9a-z_-]{45}))',
		'embed-src' => '$2',
		'embed-width' => '450',
		'embed-height' => '418',
	],
	[
		'name' => 'NewGrounds',
		'website' => 'https://www.newgrounds.com',
		'url-match' => '(https://uploads\.ungrounded\.net/(?:[0-9]{1,12})/(?:[0-9]{1,12})_(?:[0-9a-z_-]*?)\.swf)',
		'embed-src' => '$2?autostart=false&autoplay=false',
		'embed-width' => '480',
		'embed-height' => '400',
	],
	[
		'name' => 'NhacCuaTui',
		'website' => 'https://www.nhaccuatui.com',
		'url-match' => 'https?://(?:www\.)?nhaccuatui\.com/(?:nghe\?M=|m/)([a-z0-9-_]{10})',
		'embed-src' => 'https://www.nhaccuatui.com/m/$2',
		'embed-width' => '300',
		'embed-height' => '270',
	],
	[
		'name' => 'OnSmash',
		'website' => 'https://www.onsmash.com',
		'url-match' => 'https?://(?:www\.|videos\.)?onsmash\.com/(?:v|e)/([0-9a-z]{16})',
		'embed-src' => 'https://videos.onsmash.com/e/$2',
		'embed-width' => '448',
		'embed-height' => '374',
	],
	[
		'name' => 'Photobucket',
		'website' => 'https://www.photobucket.com',
		'url-match' => 'https?://media\.photobucket\.com\/video\/.*\/videos',
		'fetch-match' => '(https://vid[0-9]{1,3}\.photobucket\.com/albums/[a-z0-9]{2,5}/[a-z0-9\-_]*/videos/[a-z0-9\-_]*\.flv)',
		'embed-src' => 'https://media.photobucket.com/flash/player.swf?file=$2',
		'embed-width' => '448',
		'embed-height' => '361',
	],
	[
		'name' => 'Rambler',
		'website' => 'https://vision.rambler.ru',
		'url-match' => 'https?://vision\.rambler\.ru/(?:i/e\.swf\?id=|users/)((?:[0-9a-z_-]*?)/(?:[0-9]*?)/(?:[0-9]*))',
		'embed-src' => 'https://vision.rambler.ru/i/e.swf?id=$2&logo=1',
		'embed-width' => '390',
		'embed-height' => '370',
	],
	[
		'name' => 'RawVegas',
		'website' => 'https://www.rawvegas.tv',
		'url-match' => 'https?://(?:www\.)?rawvegas\.tv/watch/[a-z\-0-9]*/([0-9a-f]{30})',
		'embed-src' => 'https://www.rawvegas.tv/ext.php?uniqueVidID=$2',
		'embed-width' => '427',
		'embed-height' => '300',
	],
	[
		'name' => 'RuTube',
		'website' => 'https://www.rutube.ru',
		'url-match' => 'https?://(?:www\.|video\.)?rutube\.ru/(?:video/|tracks/\d+?\.html\?(?:(?:pos|related)=1&(?:amp;)?)?v=)?([0-9a-f]{32})',
		'embed-src' => 'https://video.rutube.ru/$2',
		'embed-width' => '470',
		'embed-height' => '353',
	],
	[
		'name' => 'Screencast',
		'website' => 'https://www.screencast.com',
		'url-match' => 'https://(?:www\.)?screencast\.com/t/([0-9a-zA-Z]+)',
		'fetch-match' => 'https://www\.screencast\.com/users/CamtasiaTraining/folders/Camtasia/media/([a-z0-9-]+)/embed',
		'embed-src' => 'https://content.screencast.com/users/CamtasiaTraining/folders/Camtasia/media/1d44810a-01f4-4c60-a862-6d114bed50c7/tscplayer.swf',
		'embed-width' => '425',
		'embed-height' => '344',
		'iframe-player' => 'https://www.screencast.com/users/CamtasiaTraining/folders/Camtasia/media/$2/embed'
	],
	[
		'name' => 'ScreenToaster',
		'website' => 'https://www.screentoaster.com',
		'url-match' => 'https?://(?:www\.)?screentoaster\.com/watch/([0-9a-zA-Z]+)',
		'embed-src' => 'https://www.screentoaster.com/swf/STPlayer.swf?video=$2',
		'embed-width' => '425',
		'embed-height' => '344',
		'flashvars' => 'video=$2',
	],
	[
		'name' => 'ShareView',
		'website' => 'https://www.shareview.us',
		'url-match' => 'https?://(?:www\.)?shareview\.us/video/([0-9]{1,10})/',
		'embed-src' => 'https://www.shareview.us/nvembed.swf?key=$2',
		'embed-width' => '540',
		'embed-height' => '380',
	],
	[
		'name' => 'Sharkle',
		'website' => 'https://www.sharkle.com',
		'url-match' => '(https://(?:www\.)?sharkle\.com/externalPlayer/(?:(?:(?:[0-9a-z]{1,25})/){3}))',
		'embed-src' => '$2',
		'embed-width' => '340',
		'embed-height' => '310',
	],
	[
		'name' => 'Smotri',
		'website' => 'https://www.smotri.com',
		'url-match' => 'https?://(?:www\.)?smotri\.com/video/view/\?id=v([0-9a-f]{10})',
		'embed-src' => 'https://pics.smotri.com/scrubber_custom8.swf?file=$2&bufferTime=3&autoStart=false&str_lang=eng&xmlsource=http%3A%2F%2Fpics.smotri.com%2Fcskins%2Fblue%2Fskin_color_lightaqua.xml&xmldatasource=http%3A%2F%2Fpics.smotri.com%2Fskin_ng.xml',
		'embed-width' => '400',
		'embed-height' => '330',
	],
	[
		'name' => 'Snotr',
		'website' => 'https://www.snotr.com',
		'url-match' => 'https?://(?:www\.|videos\.)?snotr\.com/(?:player\.swf\?video=|)?(?:video|embed)/([0-9]{1,8})',
		'embed-src' => 'https://videos.snotr.com/player.swf?video=$2&amp;embedded=true&amp;autoplay=false',
		'embed-width' => '400',
		'embed-height' => '330',
	],
	[
		'name' => 'SouthPark Studios',
		'website' => 'https://www.southparkstudios.com',
		'url-match' => 'https?://(?:www\.)?southparkstudios\.com/clips/([0-9]{1,10})',
		'embed-src' => 'https://media.mtvnservices.com/mgid:cms:item:southparkstudios.com:$2:',
		'embed-width' => '480',
		'embed-height' => '360',
	],
	# errors.. ex: https://www.spike.com/full-episodes/4l230e/1000-ways-to-die-stupid-as-death-does-season-3-ep-322 => https://media.mtvnservices.com/mgid:arc:video:spike.com:5fade703-67f5-4228-893b-b8afe49a6867
	[
		'name' => 'Spike',
		'website' => 'https://www.spike.com',
		'url-match' => 'https?://(?:www\.)?spike\.com/video-clips/([a-z0-9]{4,12})/',
		'embed-src' => 'https://www.spike.com/efp?flvbaseclip=$2&',
		//new: 'embed-scr' => 'https://media.mtvnservices.com/mgid:arc:video:spike.com:$2',
		'embed-width' => '448',
		'embed-height' => '365',
	],
	[
		'name' => 'Songza',
		'website' => 'https://www.songza.com',
		'url-match' => '(https://(?:www\.)?songza\.com/e/listen\?(?:zName=(?:[0-9a-z_\%-]*?)&(?:amp;)?)?zId=(?:[0-9a-z_-]{16}))',
		'embed-src' => '$2&zAutostart=false&zType=flv',
		'embed-width' => '425',
		'embed-height' => '114',
	],
	[
		'name' => 'TagTélé',
		'website' => 'https://www.tagtele.com',
		'url-match' => 'https?://www\.tagtele\.com/(?:v/|videos/voir/)([0-9]{1,12})',
		'embed-src' => 'https://www.tagtele.com/v/$2',
		'embed-width' => '425',
		'embed-height' => '350',
	],
	[
		'name' => 'Ted.com',
		'website' => 'https://www.ted.com',
		'url-match' => 'https?://(?:www\.)?ted\.com/(index.php/)?talks/[a-z0-9\-_]*.html',
		'fetch-match' => 'hs:"talks\/dynamic\/([a-z0-9-_]*)-high\.flv',
		'embed-src' => 'https://video.ted.com/assets/player/swf/EmbedPlayer.swf',
		'embed-width' => '446',
		'embed-height' => '326',
		'flashvars' => 'vu=https://video.ted.com/talks/dynamic/$2-medium.flv&su=https://images.ted.com/images/ted/tedindex/embed-posters/$2.embed_thumbnail.jpg&vw=432&vh=240',
	],
	# errors!
	[
		'name' => 'The Onion',
		'website' => 'https://www.theonion.com',
		'url-match' => 'https?://(?:www\.)?theonion\.com/video/.*',
		'fetch-match' => 'videoid\s?=\s?"([0-9]{2,7})";.*var image_url\s?=\s?escape\("([^"]*)"',
		'embed-src' => 'https://www.theonion.com/content/themes/common/assets/onn_embed/embedded_player.swf?image=$3&amp;videoid=$2',
		'embed-width' => '480',
		'embed-height' => '430',
	],
	[
		'name' => 'TinyPic',
		'website' => 'https://www.tinypic.com',
		'url-match' => 'https?://(?:www\.)?tinypic\.com/player\.php\?v=([0-9a-z-&=]{1,12})',
		'embed-src' => 'https://v5.tinypic.com/player.swf?file=$2',
		'embed-width' => '440',
		'embed-height' => '420',
	],
	[
		'name' => 'TrailerAddict',
		'website' => 'https://www.traileraddict.com',
		'url-match' => 'https?://(?:www\.)?traileraddict\.com/trailer/',
		'fetch-match' => '(https://(?:www\.)?traileraddict\.com/em(?:d|b)/(?:[0-9]{1,10}))',
		'embed-src' => '$2',
		'embed-width' => '450',
		'embed-height' => '279',
	],
	[
		'name' => 'Trilulilu',
		'website' => 'https://www.trilulilu.ro',
		'url-match' => 'https?://(?:www\.)?trilulilu\.ro/([0-9a-z_-]*?)/([0-9a-f]{14})',
		'fetch-match' => '<link rel="video_src" href="([A-z:\/\.0-9-_=?]*)\?autoplay',
		'embed-src' => '$2',
		'embed-width' => '440',
		'embed-height' => '362',
	],
	[
		'name' => 'Tu',
		'website' => 'https://www.tu.tv',
		'url-match' => '(https://tu\.tv/tutvweb\.swf\?xtp=(?:[0-9]{1,10}))',
		'embed-src' => '$2',
		'embed-width' => '425',
		'embed-height' => '350',
	],
	[
		'name' => 'Tudou',
		'website' => 'https://www.tudou.com',
		'url-match' => 'https?://(?:www\.)?tudou\.com/(?:programs/view/|v/)([a-z0-9-]{1,12})',
		'embed-src' => 'https://www.tudou.com/v/$2',
		'embed-width' => '400',
		'embed-height' => '300',
	],
	[
		'name' => 'Tumblr (Music)',
		'website' => 'https://www.tumblr.com',
		'url-match' => 'https?://[a-z0-9-_]{2,30}\.tumblr\.com/post/[0-9]{3,10}/',
		'fetch-match' => '<embed type="application/x-shockwave-flash" src="(https://[a-z0-9-_./]*\?audio_file=https://www\.tumblr\.com/audio_file/[0-9]{5,8}/[a-z0-9]{24})',
		'embed-src' => '$2&amp;color=e4e4e4',
		'embed-width' => '207',
		'embed-height' => '27',
	],
	[
		'name' => 'Ustream',
		'website' => 'https://www.ustream.tv',
		'url-match' => 'https?://www\.ustream\.tv/channel/[0-9a-z-]+',
		'fetch-match' => 'https?://www\.ustream\.tv/embed/([0-9]+)',
		'embed-src' => 'https://www.ustream.tv/flash/viewer.swf',
		'embed-width' => '480',
		'embed-height' => '299',
		'iframe-player' => 'https://www.ustream.tv/embed/$2?mode=direct',
		'flashvars' => 'cid=$2&amp;autoplay=false&amp;locale=de_DE'
	],
	[
		'name' => 'videos.sapo',
		'website' => 'https://videos.sapo.pt',
		'url-match' => 'https?://(www\.|(?:(?:(?:[0-9a-z]{3,12})\.){1,2}))?sapo\.pt/([0-9a-z]{20})',
		'embed-src' => 'https://$2sapo.pt/play?file=https://$2sapo.pt/$3/mov/1',
		'embed-width' => '400',
		'embed-height' => '322',
	],
	[
		'name' => 'Vidiac',
		'website' => 'https://www.vidiac.com',
		'url-match' => 'https?://(?:www\.)?vidiac\.com/video/((?:[0-9a-z]{8})(?:(?:-(?:[0-9a-z]{4})){3})-(?:[0-9a-z]{12}))\.htm',
		'embed-src' => 'https://www.vidiac.com/vidiac.swf?video=$2',
		'embed-width' => '428',
		'embed-height' => '352',
	],
	# errors! ex: https://www.viddler.com/explore/sandieman/videos/618/ => https://cdn.static.viddler.com/flash/publisher.swf?ref=&key=ed57527a
	[
		'name' => 'Viddler',
		'website' => 'https://www.viddler.com',
		//'url-match' => '(https://www\.viddler\.com/(?:player|simple)/(?:[0-9a-f]{8})/)',
		'url-match' => 'https?://www\.viddler\.com/explore/[a-z0-9\-_]*/videos/([0-9]*)/',
		'embed-src' => 'https://cdn.static.viddler.com/flash/simple_publisher.swf?key=$2',
		'embed-width' => '437',
		'embed-height' => '370',
	],
	[
		'name' => 'Videa',
		'website' => 'https://www.videa.hu',
		'url-match' => 'https?://(?:www\.)?videa\.hu/(?:(?:[^"]*)-|flvplayer\.swf\?v=)([0-9a-z]{16})',
		'embed-src' => 'https://videa.hu/flvplayer.swf?v=$2',
		'embed-width' => '434',
		'embed-height' => '357',
	],
	[
		'name' => 'VidiLife',
		'website' => 'https://www.vidilife.com',
		'url-match' => '(https://(?:www\.)?vidilife\.com/flash/flvplayer\.swf\?xml=https://(?:www\.)?vidilife\.com/media/play_flash_xml\.cfm\?id=(?:[0-9a-f]{8})-(?:[0-9a-f]{4})-(?:[0-9a-f]{4})-(?:[0-9a-f]{4})-(?:[0-9a-f]{1}))',
		'embed-src' => '$2',
		'embed-width' => '445',
		'embed-height' => '363',
	],
	[
		'name' => 'VidMax',
		'website' => 'https://www.vidmax.com',
		'url-match' => 'https?://(www\.)?vidmax\.com/(?:index\.php/)?videos?/(?:view/)?([0-9]{1,10})',
		'embed-src' => 'https://www.vidmax.com/player.swf',
		'embed-width' => '400',
		'embed-height' => '300',
		'flashvars' => 'file=https://www.vidmax.com/media/video/$3.flv&amp;streamer=lighttpd&amp;autostart=false&amp;stretching=fill'
	],
	[
		'name' => 'VoiceThread',
		'website' => 'https://www.voicethread.com',
		'url-match' => 'https?://(?:www\.)?voicethread\.com/(?:share/|book\.swf\?b=|#q\.b)([0-9]{1,10})',
		'embed-src' => 'https://www.voicethread.com/book.swf?b=$2',
		'embed-width' => '480',
		'embed-height' => '360',
	],
	[
		'name' => 'WeGame',
		'website' => 'https://www.wegame.com',
		'url-match' => 'https?://(?:www\.)?wegame\.com/watch/([0-9a-z_-]*?)/',
		//'embed-src' => 'https://wegame.com/static/flash/player2.swf?tag=$2',
		'embed-src' => 'https://www.wegame.com/static/flash/player.swf?xmlrequest=https://www.wegame.com/player/video/$2',
		'embed-width' => '480',
		'embed-height' => '387',
	],
	[
		'name' => 'Webshots (Slideshows)',
		'website' => 'https://www.webshots.com',
		'url-match' => 'https?://[a-z0-9\-_]*\.webshots\.com/slideshow/([a-z0-9]*)',
		'embed-src' => 'https://p.webshots.com/flash/smallslideshow.swf',
		'embed-width' => '425',
		'embed-height' => '384',
		'flashvars' => 'playList=http%3A%2F%2Fcommunity.webshots.com%2Fslideshow%2Fmeta%2F$2%3Finline%3Dtrue&inlineUrl=http%3A%2F%2Fcommunity.webshots.com%2FinlinePhoto%26src%3Ds%26referPage%3Dhttp%3A%2F%2Fgood-times.webshots.com%2Fslideshow%2F$2&postRollContent=http%3A%2F%2Fp.webshots.com%2Fflash%2Fws_postroll.swf&shareUrl=http%3A%2F%2Fgood-times.webshots.com%2Fslideshow%2F$2&audio=on&audioVolume=33&autoPlay=false&transitionSpeed=5&startIndex=0&panzoom=on&deployed=true',
	],
	[
		'name' => 'Wistia',
		'website' => 'https://www.wistia.com',
		'url-match' => 'https?://[a-z0-9\-_]*\.wistia\.com/medias/([a-z0-9]*)',
		'embed-src' => 'https://fast.wistia.net/embed/iframe/$1',
		'embed-width' => '480',
		'embed-height' => '270',
	],
	[
		'name' => 'Yahoo Video HK',
		'website' => 'https://hk.video.yahoo.com',
		'url-match' => 'https?://(?:w\.video\.)?hk\.video\.yahoo\.(?:com|net)/video/(?:dplayer\.html\?vid=|video\.html\?id=)([0-9]{1,10})',
		'embed-src' => 'https://w.video.hk.yahoo.net/video/dplayer.html?vid=$2',
		'embed-width' => '420',
		'embed-height' => '370',
	],
	# not working...
	[
		'name' => 'Yahoo Video',
		'website' => 'https://video.yahoo.com',
		//'url-match' => 'https?://(?:(?:www|uk|fr|it|es|br|au|mx|de|ca)\.)?video\.yahoo\.com/watch/([0-9]{1,12})/([0-9]{1,12})',
		'url-match' => 'https?://(?:(?:www|uk|fr|it|es|br|au|mx|de|ca)\.)?video\.yahoo\.com/(?:[^"]*?)/(?:[^"]*?)/([a-z0-9_]+)-([0-9]{1,12})',
		'embed-src' => 'https://d.yimg.com/nl/vyc/site/player.swf',
		'embed-width' => '630',
		'embed-height' => '354',
		'flashvars' => 'id=$3&vid=$2&lang=en-us&intl=us&embed=1'
	],
	[
		'name' => 'Yahoo Music Videos',
		'website' => 'https://music.yahoo.com',
		'url-match' => 'https?://(?:new\.)?(?:(?:uk|fr|it|es|br|au|mx|de|ca)\.)?music\.yahoo\.com/[^0-9]*([0-9]{1,12})$',
		'embed-src' => 'https://d.yimg.com/cosmos.bcst.yahoo.com/up/fop/embedflv/swf/fop.swf?id=v$2&eID=0000000&lang=us&enableFullScreen=0&shareEnable=1',
		'embed-width' => '400',
		'embed-height' => '255',
	],
	# offline
	[
		'name' => 'YouKu',
		'website' => 'https://www.youku.com',
		'url-match' => 'https?://(?:v\.youku\.com/v_show/id_|player\.youku\.com/player\.php/sid/)([0-9a-z]{6,14})',
		'embed-src' => 'https://player.youku.com/player.php/sid/$2=/v.swf',
		'embed-width' => '450',
		'embed-height' => '372',
	],
	# errors: https://video.sina.com.cn/v/b/49393210-2042807271.html
	[
		'name' => 'sina video',
		'website' => 'https://video.sina.com.cn',
		'url-match' => 'https?://(?:vhead\.blog|you\.video)\.sina\.com\.cn/(?:player/(?:[^"]*?)vid=|b/)([0-9]{5,12})(?:-|&(?:amp;)?uid=)([0-9]{5,12})',
		'embed-src' => 'https://vhead.blog.sina.com.cn/player/outer_player.swf?auto=0&vid=$2&uid=$3',
		'embed-width' => '480',
		'embed-height' => '370',
	],
	# https://www.xvideos.com/video566979/amber_tickle_tied_to_bed
	[
		'name' => 'XVideos',
		'website' => 'https://www.xvideos.com',
		'url-match' => 'https?://(?:www\.)?xvideos.com/video([0-9]{6,8})/(?:[^"]*?)',
		'embed-src' => 'https://static.xvideos.com/swf/flv_player_site_v4.swf',
		'embed-width' => '510',
		'embed-height' => '400',
		'flashvars' => 'id_video=$2',
	],
	[
		'name' => 'Local Content',
		'website' => 'localhost',
		'url-match' => '__local__(.*)',
		'embed-src' => '$2',
		'embed-width' => '425',
		'embed-height' => '344',
	],
	[
		'name' => 'Twitch Video',
		'website' => 'https://www.twitch.tv',
		'url-match' => 'https?://www\.twitch\.tv/videos/([0-9]{9})',
		'embed-src' => 'https://player.twitch.tv/?video=v$2',
		'embed-width' => '620',
		'embed-height' => '378',
		'iframe-player' => 'https://player.twitch.tv/?video=v$2'
	],
	[
		'name' => 'Twitch Clip',
		'website' => 'https://clips.twitch.tv',
		'url-match' => 'https?://clips\.twitch\.tv/([A-Za-z]+)',
		'embed-src' => 'https://clips.twitch.tv/embed?clip=$2',
		'embed-width' => '620',
		'embed-height' => '378',
		'iframe-player' => 'https://clips.twitch.tv/embed?clip=$2'
	],
	[
		'name' => 'Bit.Tube',
		'website' => 'https://bit.tube/',
		'url-match' => 'https:\/\/bit\.tube\/play\?(hash)=([0-9A-Za-z-]+)\&channel=([0-9]+)',
		'iframe-player' => '//bit.tube/playerembed/$2/$3/',
		'embed-src' => '',
		'embed-width' => '480',
		'embed-height' => '270',
	],
	[
		'name' => 'Vooplayer',
		'website' => 'https://vooplayer.com/',
		'url-match' => 'https:\/\/(.+)\.cdn\.vooplayer\.com/publish/([0-9A-Za-z-]+)',
		'iframe-player' => 'https://$2.cdn.vooplayer.com/publish/$3?fallback=true',
		'embed-src' => '',
		'embed-width' => '480',
		'embed-height' => '270',
	],
	[
		'name' => 'SoundCloud',
		'website' => 'https://soundcloud.com',
		'url-match' => [
			'https://soundcloud\.com/([0-9a-zA-Z-_\/]+)'
		],
		'embed-src' => '',
		'embed-width' => '100%',
		'embed-height' => '150',
		'iframe-player' => 'https://w.soundcloud.com/player/?url=https%3A%2F%2Fsoundcloud.com%2F$2',
		'id' => '$2',
	],
    [
        'name' => 'Loom',
        'website' => 'https://loom.com',
        'url-match' => [
            'https:\/\/www\.loom\.com\/(share|embed)?\/([0-9a-z-]+)'
        ],
        'embed-src' => '',
        'embed-width' => '640',
        'embed-height' => '400',
        'iframe-player' => 'https://www.loom.com/embed/$3',
        'id' => '$3',
    ]
];

/**
 * Those do not work anymore
 */
$deprecatedStubs = [
	[
		'name' => 'MegaVideo',
		'website' => 'https://www.megavideo.com',
		'url-match' => 'https?://(?:www\.)?megavideo\.com/(?:\?(?:[^"]*?)?v=|v/)([0-9a-z]{8})',
		'embed-src' => 'https://www.megavideo.com/v/$2.0.0',
		'embed-width' => '440',
		'embed-height' => '359',
	],
	[
		'name' => 'Google Video',
		'website' => 'https://video.google.com',
		'url-match' => 'https?://video\.google\.(com|com\.au|co\.uk|de|es|fr|it|nl|pl|ca|cn)/(?:videoplay|url|googleplayer\.swf)\?(?:[^"]*?)?docid=([0-9a-z-_]{1,20})',
		'embed-src' => 'https://video.google.$2/googleplayer.swf?docId=$3',
		'embed-width' => '400',
		'embed-height' => '326',
		'id' => '$3',
		'replace' => ['$2' => 'com'],
	],
	[
		'name' => 'MehrSchbass',
		'website' => 'https://www.mehr-schbass.de',
		'url-match-plain' => 'https://www.mehr-schbass\.de/videos/([0-9]{4,6})-(?:[^"]*?)',
		'url-match' => 'https?://www.mehr-schbass\.de/videos/([0-9]{4,6})-([0-9A-Za-z-]{1,100})\.html',
		'embed-src' => 'https://www.mehr-schbass.de/videos/flv_player/flvplayer.swf',
		'embed-width' => '400',
		'embed-height' => '320',
		'flashvars' => 'config=https://www.mehr-schbass.de/videos/xml-config.php?id=$2-embed',
		'id' => '$2',
	],
];

return $stubs;
